import { Component, TemplateRef, ViewChild } from '@angular/core';
import { FormGroup, FormControl, Validators } from '@angular/forms';
import { BsModalRef, BsModalService } from 'ngx-bootstrap/modal';
import { RatesMinMaxService } from '../services/rates-min-max.service';
import { getCacheData } from '../utils/helper';
import { AgentWiseCommissionService } from '../services/agent-wise-commission.service';
import { CountryWiseCommissionService } from '../services/country-wise-commission.service';
import { ToastrService } from 'ngx-toastr';



@Component({
  selector: 'app-agent-wise-commission',
  templateUrl: './agent-wise-commission.component.html',
  styleUrls: ['./agent-wise-commission.component.css'],
})
export class AgentWiseCommissionComponent {
  @ViewChild('manageAgentWise') manageAgentWiseModal;
  bsModalRef: BsModalRef;
  isLoading: boolean = false; // Loader flag

  type: any = 'add';

  currencies: any = [];
  selectedCurrency: any = 'All';
  showCheckbox: boolean = false;
  additionalCheckboxControlCheck:any=false
  sendCountries: any = [];
  selectedSendCountry: any = 'All';

  receiveCountries: any = [];
  selectedReceiveCountry: any = 'All';

  modeofPayments: any = [];
  selectedModeofPayment: any = 'All';

  sendAgents: any = [];
  Receivecurrency: any = [];
  sendCurrency: any = [];
  selectedSendAgent: any = 'All';

  receiveAgents: any = [];
  sendCurrencyValue: any ;
  sendCurrencycode: any ;
  selectedReceiveAgent: any = 'All';
  Payoutcurrencies:any
  receivingInsertAgentsSelected:any
  subAgents: any = [];
  selectedSubAgent: any = '-2';

  agentWiseCommission: any = [];

  sendInsertCountries: any = [];
  sendInsertAgents: any = [];
  modeofPaymentsInsert: any = [];
  sendInsertCurrencies: any = [];
  receiveInsertCountries: any = [];
  receiveInsertCurrencies: any = [];
  receivingInsertAgents: any = [];
  receivingSubAgents: any = [];
  totalCommissionTypes: any = [];
  sendCommissionTypes: any = [];
  receiveCommissionTypes: any = [];
  sendCurrencyTypes: any = [];
  receiveCurrencyTypes: any = [];
  rates: any = [];

  manageAgentWiseForm = new FormGroup({
    ID: new FormControl(),
    additionalCheckboxControl: new FormControl(false),
    showAdditionalInputs: new FormControl(false),
    PayInCountryID: new FormControl('None', Validators.required),
    Agent_ID: new FormControl('None', Validators.required),
    ModeOfPayment_ID: new FormControl('None', Validators.required),
    PayInCurrencyID: new FormControl('None', Validators.required),
    PayinCurrencyIDupValue: new FormControl('None', Validators.required),
    PayInCurrencyTypeUpdateValue: new FormControl('None', Validators.required),
    PayOutCurrencyTypeUpdateValue: new FormControl('None', Validators.required),
    PayOutCountryID: new FormControl('None', Validators.required),
    PayOutCurrencyID: new FormControl('None', Validators.required),
    PayOutCurrencyIDUpdate: new FormControl('None', Validators.required),
    RecAgent_IDUpdateID: new FormControl('None', Validators.required),
    RecSubAgent_IDUpdateID: new FormControl('None', Validators.required),
    RecAgent_ID: new FormControl('None', Validators.required),
    RecSubAgent_ID: new FormControl('None', Validators.required),
    RangeCurrencyType: new FormControl('None', Validators.required),
    StartRange: new FormControl('', Validators.required),
    EndRange: new FormControl('', Validators.required),
    BaseToBaseCommissionAmount: new FormControl('', Validators.required),
    PayCommissionType: new FormControl('None', Validators.required),
    PayInCommissionType: new FormControl('None', Validators.required),
    PayInCurrencyType: new FormControl('None', Validators.required),
    PayInCommissionAmount: new FormControl('None', Validators.required),
    PayOutCommissionType: new FormControl('None', Validators.required),
    PayOutCurrencyType: new FormControl('None', Validators.required),
    PayOutCommissionAmount: new FormControl('', Validators.required),
    FixedAmount: new FormControl(''),
    MinAmount: new FormControl(''),
    MaxAmount: new FormControl(''),
  });

  constructor(
    private agentWiseService: AgentWiseCommissionService,
    private countryCommissionService: CountryWiseCommissionService,
    private ratesService: RatesMinMaxService,
    private modalService: BsModalService,
    private toastrSvc: ToastrService

  ) { }

  ngOnInit(): void {
    this.getSendCountry();
    this.getModeofPayment();
    this.getSendCountryInsert();
    this.getReceiveCountryInsert();
    this.getTotalCommissionType();

    this.manageAgentWiseForm
      .get('PayOutCurrencyType')
      .valueChanges.subscribe(() => {
        if (!this.isPayOutCurrencyType2()) {
          this.manageAgentWiseForm.get('showAdditionalInputs').setValue(false);
          this.resetAdditionalInputs();
        }
      });
  }
  get disabledInput() {
    return this.checkType == 'View' ? true : false;
  }
  getSendCountry() {
    this.agentWiseService
      .getSendCountry(getCacheData('admin_token'), getCacheData('username'))
      .subscribe({
        next: (res: any) => {
          this.sendCountries = res;
        },
        error: () => {
          this.sendCountries = [];
        },
        complete: () => { },
      });
  }

  getReceiveCountry(payInCountryId = 0) {
    this.agentWiseService
      .getReceiveCountry(
        getCacheData('admin_token'),
        getCacheData('username'),
        payInCountryId
      )
      .subscribe({
        next: (res: any) => {
          this.receiveCountries = res;
        },
        error: () => {
          this.receiveCountries = [];
        },
        complete: () => { },
      });
  }
  isPayOutCurrencyType2(): boolean {
    const payOutCurrencyTypeValue = Number(
      this.manageAgentWiseForm.get('PayOutCommissionType').value
    );

    return payOutCurrencyTypeValue == 2;
  }

  resetAdditionalInputs() {
    this.manageAgentWiseForm.get('FixedAmount1').reset();
    this.manageAgentWiseForm.get('FixedAmount2').reset();
    this.manageAgentWiseForm.get('MinAmount').reset();
    this.manageAgentWiseForm.get('MaxAmount').reset();
  }

  isAdditionalInputsShown(): boolean {
    return this.manageAgentWiseForm.get('showAdditionalInputs').value;
  }

  getModeofPayment() {
    this.agentWiseService
      .getModeofPayment(getCacheData('admin_token'), getCacheData('username'))
      .subscribe({
        next: (res: any) => {
          this.modeofPayments = res;
        },
        error: () => {
          this.modeofPayments = [];
        },
        complete: () => { },
      });
  }

  async  getSendAgent(payInCountryId = 0) {
    this.agentWiseService
      .getSendAgent(
        getCacheData('admin_token'),
        getCacheData('username'),
        payInCountryId
      )
      .subscribe({
        next: (res: any) => {
          this.sendAgents = res;
        },
        error: () => {
          this.sendAgents = [];
        },
        complete: () => { },
      });
  }
  async  getReceivecurrency(CountryId = 0,CurrencyId:any) {
    this.agentWiseService
      .getReceivecurrency(
       
        CountryId
      )
      .subscribe({
        next: (res: any) => {
          console.log(CurrencyId,"CurrencyId",res,CountryId)
          if(CurrencyId == 1){

            let formattedRes = res.map(item => ({
              ID: item.Currency_Id,
              CurrencyType: item.CurrencyShortName
          }));
            this.Payoutcurrencies =[{ ID: 1, CurrencyType: 'USD' }]
            this.receiveCurrencyTypes.push(this.Payoutcurrencies[0]);
            this.receiveCurrencyTypes.push(formattedRes[0]);
            this.receiveInsertCurrencies=res
          }else{ 
            
            this.Payoutcurrencies = res.filter((c: any) => c.Currency_Id == CurrencyId);
            this.Receivecurrency = res;
            this.receiveInsertCurrencies=res
            let formattedRes = res.map(item => ({
              ID: item.Currency_Id,
              CurrencyType: item.CurrencyShortName
          }));
            this.receiveCurrencyTypes.push(formattedRes[0]);
          }
         
        },
        error: () => {
          this.Receivecurrency = [];
        },
        complete: () => { },
      });
  }
  async  getSendAgentGetvalue(PayOutCountry = 0,Agent_ID:any) {
    this.agentWiseService
      .getOutCountry(
       
        PayOutCountry
      )
      .subscribe({
        next: (res: any) => {
          this.receivingInsertAgentsSelected = res.filter((c: any) => c.Agent_ID == Agent_ID);
          this.receivingInsertAgents = res;
        },
        error: () => {
          this.receivingInsertAgents = [];
        },
        complete: () => { },
      });
  }
  async getSendCurrency(CountryID :any,AgentID:any,PayInCurrencyID) {
    this.agentWiseService
      .getSendcurrency(
        CountryID,
        AgentID
      )
      .subscribe({
        next: (res: any) => {
          this.sendCurrencyValue = res.filter((currency: any) => currency.Currency_Id == PayInCurrencyID);
          this.sendCurrencycode= this.sendCurrencyValue[0].CurrencyShortName;
          console.log(    "this.sendCurrencyValue",res,AgentID,CountryID,PayInCurrencyID)
          this.sendCurrency = res;
          let formattedRes = res.map(item => ({
            ID: item.Currency_Id,
            CurrencyType: item.CurrencyShortName
        }));
          this.sendCurrencyTypes.push(formattedRes[0]);
        },
        error: () => {
          this.sendCurrency = [];
        },
        complete: () => { },
      });
  }

  onSendCountryChange() {
    if (this.selectedSendCountry != 'All') {
      this.getReceiveCountry(this.selectedSendCountry);
      this.getSendAgent(this.selectedSendCountry);
    }
  }

  getReceiveAgent(payOutCountryId = 0) {
    this.agentWiseService
      .getReceiveAgent(
        getCacheData('admin_token'),
        getCacheData('username'),
        payOutCountryId
      )
      .subscribe({
        next: (res: any) => {
          this.receiveAgents = res;
        },
        error: () => {
          this.receiveAgents = [];
        },
        complete: () => { },
      });
  }

  getSubAgent(receiveAgentId = 0) {
    this.agentWiseService
      .getSubAgent(
        getCacheData('admin_token'),
        getCacheData('username'),
        receiveAgentId
      )
      .subscribe({
        next: (res: any) => {
          this.subAgents = res;
        },
        error: () => {
          this.subAgents = [];
        },
        complete: () => { },
      });
  }

  onReceiveCountryChange() {
    if (this.selectedReceiveCountry != 'All') {
      this.getReceiveAgent(this.selectedReceiveCountry);
    }
  }

  onReceiveAgentChange() {
    if (this.selectedReceiveAgent != 'All') {
      this.getSubAgent(this.selectedReceiveAgent);
    }
  }

  getAllAgentWiseCommission(
    payInCountryId: any = 0,
    payOutCountryId: any = 0,
    agentId: any = 0,
    receiveAgentId: any = 0,
    modeofPaymentId: any = 0,
    subAgentId: any
  ) {
    this.isLoading = true;
    this.agentWiseService
      .getAllAgentWiseCommission(
        getCacheData('admin_token'),
        getCacheData('username'),
        payInCountryId,
        payOutCountryId,
        agentId,
        receiveAgentId,
        modeofPaymentId,
        this.selectedSubAgent !== 'None' ? subAgentId : '-'
      )
      .subscribe({
        next: (res: any) => {
          this.isLoading = false;
          if (res?.length == 0) {
            alert('No data found.');
            return;
          }
          this.agentWiseCommission = res;
          this.formatAgentWiseCommission(this.agentWiseCommission);
        },
        error: () => {
          this.isLoading = false;
          this.agentWiseCommission = [];
        },
        complete: () => { },
      });
  }

  searchAgentWiseCommission() {
    let payInCountryId: number | null = 0;
    let payOutCountryId: number | null = 0;
    let agentId: number | null = 0;
    let receiveAgentId: number | null = 0;
    let modeofPaymentId: number | null = 0;
    let subAgentId: number | null = 0;
    if (this.selectedSendCountry != 'All') {
      payInCountryId = this.selectedSendCountry;
    }
    if (this.selectedReceiveCountry != 'All') {
      payOutCountryId = this.selectedReceiveCountry;
    }
    if (this.selectedSendAgent != 'All') {
      agentId = this.selectedSendAgent;
    }
    if (this.selectedReceiveAgent != 'All') {
      receiveAgentId = this.selectedReceiveAgent;
    }
    if (this.selectedModeofPayment != 'All') {
      modeofPaymentId = this.selectedModeofPayment;
    }
    if (this.selectedSubAgent != 'All') {
      subAgentId = this.selectedSubAgent;
    }

    this.getAllAgentWiseCommission(
      payInCountryId,
      payOutCountryId,
      agentId,
      receiveAgentId,
      modeofPaymentId,
      subAgentId
    );
  }

  get f() {
    return this.manageAgentWiseForm.value;
  }

  // openModal(template: TemplateRef<any>) {
  //   this.bsModalRef = this.modalService.show(template);
  // }
  openModal(template: TemplateRef<any>) {
    const modalConfig = {
      class: 'modal-lg'  // Small modal size
    };
    this.bsModalRef = this.modalService.show(template, modalConfig);
  }
  

  openAgentWiseModal(type: any) {
    this.type = type;
    if (type === 'add') {
      this.manageAgentWiseForm.reset({
        PayInCountryID: 'None',
        PayInCurrencyID: 'None',
        Agent_ID: 'None',
        ModeOfPayment_ID: 'None',
        PayOutCountryID: 'None',
        PayOutCurrencyID: 'None',
        RecAgent_ID: 'None',
        RecSubAgent_ID: 'None',
        RangeCurrencyType: 'None',
        StartRange: '',
        EndRange: '',
        BaseToBaseCommissionAmount: '',
        PayCommissionType: 'None',
        PayInCommissionType: 'None',
        PayOutCommissionType: 'None',
        PayInCurrencyType: 'None',
        PayInCommissionAmount: '',
        PayOutCurrencyType: 'None',
        PayOutCommissionAmount: '',
      });
    }

    this.openModal(this.manageAgentWiseModal);
  }

  addAgentCommission() {
    // Form validation checks
 
  
    if (this.f.PayInCountryID == 'None') {
      alert('Please Select Send Country!');
      return;
    }
  
    if (this.f.PayInCurrencyID == 'None') {
      alert('Please Select Send Currency!');
      return;
    }
  
    if (this.f.PayOutCountryID == 'None') {
      alert('Please Select Receive Country!');
      return;
    }
  
    if (this.f.PayOutCurrencyID == 'None') {
      alert('Please Select Receive Currency!');
      return;
    }
  
    if (this.f.ModeOfPayment_ID == 'None') {
      alert('Please Select Mode of Payment!');
      return;
    }
  
    if (this.f.RecAgent_ID == 'None') {
      alert('Please Select Receiving Agent!');
      return;
    }
  
    // Uncomment if Receiving Sub Agent is required
    // if (this.f.RecSubAgent_ID == 'None') {
    //   alert('Please Select Receiving Sub Agent!');
    //   return;
    // }
  
    if (this.f.RangeCurrencyType == 'None') {
      alert('Please Select Range Currency Type!');
      return;
    }
  
    if (this.f.EndRange < this.f.StartRange) {
      alert('End Range should be greater than Start Range!');
      return;
    }
  
    if (this.f.PayCommissionType == 'None') {
      alert('Please Select Total Commission Type!');
      return;
    }
  
    if (this.f.PayInCommissionType == 'None') {
      alert('Please Select Send Commission Type!');
      return;
    }
  
    if (this.f.PayInCurrencyType == 'None') {
      alert('Please Select Send Currency Type!');
      return;
    }
  
    if (this.f.PayOutCommissionType == 'None') {
      alert('Please Select Receive Commission Type!');
      return;
    }
  
    if (this.f.PayOutCurrencyType == 'None') {
      alert('Please Select Receive Currency Type!');
      return;
    }
  
    if (this.f.additionalCheckboxControl) {
     
      if (this.f.MinAmount >= this.f.MaxAmount) {
        alert("Minimum amount should be less than Maximum amount.");
        return;
      }
    }
  
    // Define payload for 'add' action
    let payload: any = {
      PayInCountryID: this.f.PayInCountryID,
      Agent_ID: this.f.Agent_ID,
      PayInCurrencyID: this.f.PayInCurrencyID,
      PayOutCountryID: this.f.PayOutCountryID,
      PayOutCurrencyID: this.f.PayOutCurrencyID,
      ModeOfPayment_ID: this.f.ModeOfPayment_ID,
      StartRange: this.f.StartRange,
      EndRange: this.f.EndRange,
      BaseToBaseCommissionAmount: this.f.BaseToBaseCommissionAmount,
      PayCommissionType: this.f.PayCommissionType,
      PayInCommissionType: this.f.PayInCommissionType,
      PayInCurrencyType: this.f.PayInCurrencyType,
      PayInCommissionAmount: this.f.PayInCommissionAmount,
      PayOutCommissionType: this.f.PayOutCommissionType,
      PayOutCurrencyType: this.f.PayOutCurrencyType,
      PayOutCommissionAmount: this.f.PayOutCommissionAmount,
      EnteredBy: getCacheData('G_UserID'),
      RecAgent_ID: this.f.RecAgent_ID ,
      RangeCurrencyType: this.f.RangeCurrencyType,
      RecSubAgent_ID: this.f.RecSubAgent_ID,  // Corrected from RangeCurrencyType to RecSubAgent_ID
      ReceiverFixAmount: this.f.FixedAmount || 0,
      ReceiverMinAmount: this.f.MinAmount || 0,
      ReceiverMaxAmount: this.f.MaxAmount || 0,
      IsReceiverMixMaxSet: this.f.additionalCheckboxControl || false
    };
  
    // Define payload for 'edit' action
    if (this.type === 'edit') {

      const selectedPayinCurrencyID = this.sendInsertCurrencies.find(
        currency => currency.CurrencyShortName === this.f.PayInCurrencyID
      )?.Currency_Id ?? this.f.PayinCurrencyIDupValue;
    
      const selectedPayOutCountryID = this.receiveInsertCountries.find(
        country => country.CountryName === this.f.PayOutCountryID
      )?.CountryId ?? this.f.PayOutCountryID;
    
      const selectedPayOutCurrencyID = this.receiveInsertCurrencies.find(
        currency => currency.CurrencyShortName === this.f.PayOutCurrencyID
      )?.Currency_Id ?? this.f.PayOutCurrencyIDUpdate;
    
      const selectedCommissionTypeID = this.totalCommissionTypes.find(
        type => type.CommissionType === this.f.PayCommissionType
      )?.ID ?? this.f.PayCommissionType;
    
      const selectedModeOfPaymentID = this.modeofPaymentsInsert.find(
        payment => payment.ModeOfPayment_Name === this.f.ModeOfPayment_ID
      )?.ModeOfPayment_ID ?? this.f.ModeOfPayment_ID;
    
      const selectedCommissionTypes = this.sendCommissionTypes.find(
        payment => payment.CommissionType === this.f.PayInCommissionType
      )?.ID ?? this.f.PayInCommissionType;
    
      const selectsendCurrencyTypes = this.sendCurrencyTypes.find(
        payment => payment.CurrencyType == this.f.PayInCurrencyType
      )?.ID ?? this.f.PayInCurrencyTypeUpdateValue;
    


      const SelectedreceiveCommissionTypes = this.receiveCommissionTypes.find(
        payment => payment.CommissionType === this.f.PayOutCommissionType
      )?.ID ?? this.f.PayOutCommissionType;
    
      const SelectedreceiveCurrencyTypes = this.receiveCurrencyTypes.find(
        payment => payment.CurrencyType == this.f.PayOutCurrencyType
      )?.ID ?? this.f.PayOutCurrencyTypeUpdateValue;

      console.log(SelectedreceiveCurrencyTypes,"selectsendCurrencyTypes")


    
      const SelectedreceiveInsertCurrencies = this.receiveInsertCurrencies.find(
        payment => payment.CurrencyShortName == this.f.RangeCurrencyType
      )?.Currency_Id ?? this.f.RangeCurrencyType;
    
      const SelectedreceivingSubAgents = this.receivingSubAgents.find(
        payment => payment.AgentBranch_Name === this.f.RecSubAgent_ID
      )?.Agent_ID ?? this.f.RecSubAgent_ID;

      console.log(SelectedreceiveCurrencyTypes)
      if (this.f.additionalCheckboxControl) { // Check if the checkbox control is true
        // Validate FixedAmount
        if (this.f.FixedAmount === '') {
          alert('Please Enter Fixed Amount!');
          return;
        }
      
        // Validate MinAmount
        if (this.f.MinAmount === '') {
          alert('Please Enter Min Amount!');
          return;
        }
      
        // Validate MaxAmount
        if (this.f.MaxAmount === '') {
          alert('Please Enter Max Amount!');
          return;
        }
      
        // Convert MinAmount and MaxAmount to numbers to ensure numeric comparison
        const minAmount = parseFloat(this.f.MinAmount);
        const maxAmount = parseFloat(this.f.MaxAmount);
     
       
        if (maxAmount <= minAmount) {
          alert('Max Amount should be greater than Min Amount!');
          return;
        }
      }else{
        this.manageAgentWiseForm.patchValue({
          additionalCheckboxControl:false,
          FixedAmount: "0",
          MinAmount: "0",
          MaxAmount:  "0",
        });
      }

      payload = {
        ID: this.f.ID,
        Agent_ID:this.f.Agent_ID,
        PayInCountryID: this.f.PayInCountryID,
        PayInCurrencyID:selectedPayinCurrencyID || this.f.PayinCurrencyIDupValue,
        PayOutCountryID: selectedPayOutCountryID,
        PayOutCurrencyID: selectedPayOutCurrencyID || this.f.PayOutCurrencyIDUpdate,
        ModeOfPayment_ID: selectedModeOfPaymentID,
        StartRange: this.f.StartRange,
        EndRange: this.f.EndRange,
        BaseToBaseCommissionAmount: this.f.BaseToBaseCommissionAmount,
        PayCommissionType: selectedCommissionTypeID,
        PayInCommissionType: selectedCommissionTypes,
        PayInCurrencyType: selectsendCurrencyTypes || this.f.PayInCurrencyTypeUpdateValue,
        PayInCommissionAmount: this.f.PayInCommissionAmount,
        PayOutCommissionType:SelectedreceiveCommissionTypes,
        PayOutCurrencyType: SelectedreceiveCurrencyTypes || this.f.PayOutCurrencyTypeUpdateValue,
        PayOutCommissionAmount: this.f.PayOutCommissionAmount,
        EnteredBy: getCacheData('G_UserID'),
        LastModifiedDate: new Date().toISOString(),
        RangeCurrencyType: SelectedreceiveInsertCurrencies,
        RecSubAgent_ID: SelectedreceivingSubAgents || this.f.RecSubAgent_IDUpdateID,  // Corrected from RangeCurrencyType to RecSubAgent_ID
        ReceiverFixAmount: this.f.FixedAmount || 0,
        ReceiverMinAmount: this.f.MinAmount || 0,
        ReceiverMaxAmount: this.f.MaxAmount || 0,
        IsReceiverMixMaxSet: this.f.additionalCheckboxControl || false
      };
    }
  
    if (this.type === 'view') {
      console.log('this.f.ID: ', this.f.ID);
      this.approveAgentWiseCommission(1, this.f.ID);
      return;
    }
  
    const serviceMethod =
      this.type === 'add'
        ? 'addAgentWiseCommission'
        : 'updateAgentWiseCommission';
  
    this.agentWiseService[serviceMethod](payload).subscribe({
      next: (res: any) => {
        this.modalService.hide();
        this.searchAgentWiseCommission();
     
        alert(res);
      },
      error: (err) => {
        this.modalService.hide();
        // alert(err?.error?.message || 'Something went wrong');
        this.toastrSvc.error(err?.error?.message)
      },
      complete: () => {
        this.modalService.hide();
      },
    });
  
    this.openModal(this.manageAgentWiseModal);
  }
  

  approveAgentWiseCommission(moduleID: any = 1, Id: any) {
    this.agentWiseService.approveAgentWiseCommission(moduleID, Id).subscribe({
      next: (res: any) => {
        this.modalService.hide();
      },
      error: (err) => {
        this.modalService.hide();
        // alert(err?.error?.message || 'Something went wrong');
        this.toastrSvc.error(err?.error?.message)
      },
      complete: () => {
        this.modalService.hide();
      },
    });
  }

  editRates(rate: any) {
    // this.manageAgentWiseForm.patchValue({
    //   ID: rate?.ID,
    //   CurrencyId: currencyId,
    //   RatePer: rate?.RatePER,
    // });
    this.openAgentWiseModal('edit');
  }

  isRatesPerValid(rate: number): boolean {
    return !!rate;
  }

  updateRates(): void {
    const updatedRates = this.rates
      .filter((con) => con.isChecked)
      .map((con) => {
        return {
          IsCheckEdit: true,
          IsActive: true,
          Id: con?.ID,
          RatePer: con?.RatePER,
          UserID: getCacheData('G_UserID'),
        };
      });
    if (updatedRates?.length) {
      this.ratesService
        .updateRates(
          getCacheData('admin_token'),
          getCacheData('username'),
          updatedRates
        )
        .subscribe({
          next: (res: any) => {
            this.modalService.hide();
          },
          error: (err) => {
            this.modalService.hide();
            // alert(err?.error?.message || 'Something went wrong');
            this.toastrSvc.error(err?.error?.message)
          },
          complete: () => {
            this.modalService.hide();
          },
        });
    }
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  getSendCountryInsert() {
    this.agentWiseService
      .getSendCountryInsert(
        getCacheData('admin_token'),
        getCacheData('username')
      )
      .subscribe({
        next: (res: any) => {
          this.sendInsertCountries = res;
          this.getSendAgentInsert(res?.[0]?.CountryId);
          this.getSendCurrencyInsert(res?.[0]?.CountryId);
        },
        error: () => {
          this.sendInsertCountries = [];
        },
        complete: () => { },
      });
  }
  async editCountryWiseCommission(country: any, type: any) {
    this.getAgentWiseCommissionDataById(country.ID, type);
  }

  getAgentWiseCommissionDataById(id: any, type) {
    console.log("sdf",this.selectedSubAgent)
    this.agentWiseService.getAgentWiseCommissionDataById(id,this.selectedSubAgent).subscribe({
      next: (res: any) => {
        const getAgentWiseData = res[0];

        this.filledValue(getAgentWiseData, type);
      },
      error: () => { },
      complete: () => { },
    });
  }

  get checkType() {
    let type = this.type;
    switch (type) {
      case 'add':
        return (type = 'Add');
      case 'edit':
        return (type = 'Update');
      case 'view':
        return (type = 'View');
      default:
        return type;
    }
  }

  async filledValue(data: any, type) {
    if (!data) {
      console.error('Error: data is undefined or null');
      return;
    }


    this.getSendCurrencyInsert(data.PayInCountryId)
    this.onSendInsertCountryChange(data.PayInCountryId)
    this.getSendCurrencyType(data.PayInCountryId)
    this.onReceiveCountryInsertChange(data.PayOutCountryId)
    this.onReceiveCurrencyInsertChange(data.PayOutCurrencyID)
  console.log(data)
    try {
      await Promise.all([
        this.getSendCurrency(data.PayInCountryId, data.Agent_ID, data.PayInCurrencyID),
        this.getSendAgent(data.PayInCountryId),
        this.getReceivecurrency(data.PayOutCountryId,data.PayOutCurrencyType),
        this.getSendAgentGetvalue(data.PayOutCountryId,data.ReceivingAgent),
        this.getReceiveSubAgentInsert(data.ReceivingAgent)
      ]);
      await new Promise(resolve => setTimeout(resolve, 1000)); // Adjust the delay as needed

    
  
      const sendAgentsValue = this.sendAgents.find(
        (c) => c.Agent_ID == data.Agent_ID
      )?.Agent_ID;
  
      const PayInCountryID = this.sendInsertCountries.find(
        (c) => c.CountryId == data?.PayInCountryId
      )?.CountryId;
  
      const payOutCountryID = this.receiveCountries.find(
        (c) => c.PayOutCountryId == data.PayOutCountryId
      )?.CountryName;
  
      const payInCurrencyId = this.sendInsertCurrencies.find(
        (c) => c.Currency_Id == data.PayInCurrencyID
      )?.CurrencyShortName;
  
      const payOutCurrencyId = this.receiveInsertCurrencies.find(
        (c) => c.Currency_Id == data.PayOutCurrencyID
      )?.CurrencyShortName;
  
      const modeofPaymentId = this.modeofPaymentsInsert.find(
        (c) => c.ModeOfPayment_ID == data.ModeOfPayment_ID
      )?.ModeOfPayment_Name;
  
      const payCommissionType = this.totalCommissionTypes.find(
        (c) => c.ID == data.PayCommissionType
      )?.CommissionType;
  
      const PayInCommissionType = this.sendCommissionTypes.find(
        (c) => c.ID == data.PayInCommissionType
      )?.CommissionType;
  
      const payInCurrencyType = this.sendCurrencyTypes.find(
        (c) => c.ID == data.PayInCurrencyType
      )?.CurrencyType;
  
      const payOutCommissionType = this.receiveCommissionTypes.find(
        (c) => c.ID == data.PayOutCommissionType
      )?.CommissionType;
  
      const payOutCurrencyType = this.receiveCurrencyTypes.find(
        (c) => c.ID == data.PayOutCurrencyType
      )?.CurrencyType;
  
      const RangeCurrencyType = this.receiveCurrencyTypes.find(
        (c) => c.ID == data.RangeCurrencyType
      )?.CurrencyType;
  
      const PayOutCurrencyIDvalue = this.receiveCurrencyTypes.find(
        (c) => c.ID == data.PayOutCurrencyID
      )?.CurrencyType;
  
      console.log(PayOutCurrencyIDvalue,RangeCurrencyType, data.PayOutCurrencyID,data.RangeCurrencyType,this.receiveInsertCurrencies)
      const checkBOx = data?.IsPayOutMinMax ;

      console.log(checkBOx)
      this.showCheckbox=checkBOx
      if(this.showCheckbox)
      {
       this.additionalCheckboxControlCheck=checkBOx
      } else{
       this.additionalCheckboxControlCheck=''
      }
     
    
        
           
        
            let uniqueIDs = new Set();
            this.receiveCurrencyTypes = this.receiveCurrencyTypes.filter(currency => {
                if (!uniqueIDs.has(currency.ID)) {
                    uniqueIDs.add(currency.ID);
                    return true;
                }
                return false;
            });
            let uniqueIDssendCurrencyTypes = new Set();
            this.sendCurrencyTypes = this.sendCurrencyTypes.filter(currency => {
                if (!uniqueIDssendCurrencyTypes.has(currency.ID)) {
                  uniqueIDssendCurrencyTypes.add(currency.ID);
                    return true;
                }
                return false;
            });
  
            console.log(  this.receiveCurrencyTypes,'dropvalue')

      this.manageAgentWiseForm.patchValue({
        ID: data?.ID,
        PayInCountryID: PayInCountryID || '',
        PayInCurrencyID: this.sendCurrencycode,
        PayinCurrencyIDupValue:data.PayInCurrencyID,
        PayOutCountryID: payOutCountryID,
        PayOutCurrencyID: this.Payoutcurrencies[0].CurrencyShortName || PayOutCurrencyIDvalue,
        PayOutCurrencyIDUpdate: data.PayOutCurrencyID,
        ModeOfPayment_ID: modeofPaymentId,
        StartRange: data?.StartRange,
        EndRange: data?.EndRange,
        BaseToBaseCommissionAmount: data?.BaseToBaseCommissionAmount,
        PayCommissionType: payCommissionType,
        PayInCommissionType: PayInCommissionType,
        PayInCurrencyType: this.sendCurrencycode,
        PayInCurrencyTypeUpdateValue: data.PayInCurrencyType,
        PayOutCurrencyTypeUpdateValue: data.PayOutCurrencyType,
        PayInCommissionAmount: data?.PayInCommissionAmount,
        PayOutCommissionType: payOutCommissionType,
        PayOutCurrencyType:this.Payoutcurrencies[0].CurrencyShortName ||  this.Payoutcurrencies[0].CurrencyType ,
        PayOutCommissionAmount: data?.PayOutCommissionAmount,
        Agent_ID: sendAgentsValue,
        RecAgent_ID: this.receivingInsertAgentsSelected[0].AgentName,
        RecAgent_IDUpdateID: data.ReceivingAgent,
        RecSubAgent_IDUpdateID:  data.ReceivingAgent,
        RangeCurrencyType: this.Payoutcurrencies[0].CurrencyShortName || RangeCurrencyType ,
        additionalCheckboxControl: checkBOx,
        FixedAmount: data.PayOutFixAmount,
        MinAmount:data?.PayOutMinAmount ,
        MaxAmount:data?.PayOutMaxAmount,
      });
  
      this.openAgentWiseModal(type);
    } catch (error) {
      console.error('Error in filledValue:', error);
    }
  }
  

  getSendAgentInsert(payInCountryId = 0) {
    this.agentWiseService
      .getSendAgentInsert(
        getCacheData('admin_token'),
        getCacheData('username'),
        payInCountryId
      )
      .subscribe({
        next: (res: any) => {
          this.sendInsertAgents = res;
          this.getModeofPaymentInsert(res?.[0]?.Agent_ID);
          // this.getSendCurrencyType();
        },
        error: () => {
          this.sendInsertAgents = [];
        },
        complete: () => { },
      });
  }

  getModeofPaymentInsert(agentId = 0) {
    this.agentWiseService
      .getModeofPaymentInsert(
        getCacheData('admin_token'),
        getCacheData('username'),
        agentId
      )
      .subscribe({
        next: (res: any) => {
          this.modeofPaymentsInsert = res;
        },
        error: () => {
          this.modeofPaymentsInsert = [];
        },
        complete: () => { },
      });
  }

  getSendCurrencyInsert(countryId: any = 0) {
    this.agentWiseService
      .getSendCurrencyInsert(
        getCacheData('admin_token'),
        getCacheData('username'),
        countryId
      )
      .subscribe({
        next: (res: any) => {
          this.sendInsertCurrencies = res;
        },
        error: () => {
          this.sendInsertCurrencies = [];
        },
        complete: () => { },
      });
  }

  onSendInsertCountryChange(countryId: any) {
    if (countryId != 'None') {
      this.getSendAgentInsert(countryId);
    }
  }

  onSendInsertAgentChange(agentId: any) {
    if (agentId != 'None') {
      this.getModeofPaymentInsert(agentId);
    }
  }

  onSendInsertModeofPayment(modeofPaymentId: any) {
    if (modeofPaymentId != 'None') {
      this.getSendCurrencyInsert(this.f.PayInCountryID);
    }
  }

  getReceiveCountryInsert() {
    this.agentWiseService
      .getReceiveCountryInsert(
        getCacheData('admin_token'),
        getCacheData('username')
      )
      .subscribe({
        next: (res: any) => {
          this.receiveInsertCountries = res;
          this.getReceiveCurrencyInsert(res?.[0]?.CountryId);
        },
        error: () => {
          this.receiveInsertCountries = [];
        },
        complete: () => { },
      });
  }

  onReceiveCountryInsertChange(countryId: any) {
    if (countryId != 'None') {
      this.getReceiveCurrencyInsert(countryId);
    }
  }


 

  getReceiveCurrencyInsert(payOutCountryId = 0) {
    this.agentWiseService
      .getReceiveCurrencyInsert(
        getCacheData('admin_token'),
        getCacheData('username'),
        payOutCountryId
      )
      .subscribe({
        next: (res: any) => {
          this.receiveInsertCurrencies = res;
          console.log("object",this.receiveInsertCurrencies)
          this.getReceiveAgentInsert(res?.[0]?.Currency_Id, payOutCountryId);
        },
        error: () => {
          this.receiveInsertCurrencies = [];
        },
        complete: () => { },
      });
  }

  onReceiveCurrencyInsertChange(currencyId: any) {
    if (currencyId != 'None') {

      let filteredCurrencies = this.receiveInsertCurrencies
      .filter(currency => currency.Currency_Id == currencyId)
      .map(currency => ({
        ID: currency.Currency_Id,
        CurrencyType: currency.CurrencyShortName
      }));
      this.receiveCurrencyTypes = [ ...filteredCurrencies,{ ID: 1, CurrencyType: 'USD' }];
    
      this.receiveCurrencyTypes = this.receiveCurrencyTypes.reduce((unique, o) => {
        if (!unique.some(obj => obj.ID === o.ID)) {
          unique.push(o);
        }
        return unique;
      }, []);



      this.manageAgentWiseForm.patchValue({
        RangeCurrencyType: currencyId,
      });
      this.getReceiveAgentInsert(currencyId, this.f.PayOutCountryID);
    }
  }

  getReceiveAgentInsert(receiveCurrencyId: any = 0, payOutCountryId: any = 0) {
    this.agentWiseService
      .getReceiveAgentInsert(
        getCacheData('admin_token'),
        getCacheData('username'),
        receiveCurrencyId,
        payOutCountryId
      )
      .subscribe({
        next: (res: any) => {

          this.receivingInsertAgents = res;
          this.getReceiveSubAgentInsert(res?.[0]?.Agent_ID);
        },
        error: () => {
          this.receivingInsertAgents = [];
        },
        complete: () => { },
      });
  }



  onReceiveCurrencyChange(countryId: any) {
    if (countryId != 'None') {
  
      // this.getReceiveCurrencyType();
    }
  }


  onReceiveAgentInsertChange(agentId: any) {
    if (agentId != 'None') {
      this.getReceiveSubAgentInsert(agentId);
    }
  }

  getReceiveSubAgentInsert(agentId: any = 0) {
    this.agentWiseService
      .getReceiveSubAgentInsert(
      
        agentId
      )
      .subscribe({
        next: (res: any) => {
          this.receivingSubAgents = res;
        },
        error: () => {
          this.receivingSubAgents = [];
        },
        complete: () => { },
      });
  }

  getTotalCommissionType() {
    this.countryCommissionService
      .getTotalCommissionType(
        getCacheData('admin_token'),
        getCacheData('username')
      )
      .subscribe({
        next: (res: any) => {
          this.totalCommissionTypes = res;
          this.getSendCommissionType();
          this.getReceiveCommissionType();
        },
        error: () => {
          this.totalCommissionTypes = [];
        },
        complete: () => { },
      });
  }

  getSendCommissionType() {
    if (this.totalCommissionTypes?.length) {
      this.sendCommissionTypes = this.totalCommissionTypes;
    }
  }

  getReceiveCommissionType() {
    if (this.totalCommissionTypes?.length) {
      this.receiveCommissionTypes = this.totalCommissionTypes;
    }
  }

  getSendCurrencyType(countryId) {
    this.countryCommissionService
      .getCurrencyType(getCacheData('admin_token'), getCacheData('username'))
      .subscribe({
        next: (res: any) => {

          let filteredCurrencies = this.sendInsertCurrencies
          .filter(currency => currency.Currency_Id == countryId)
          .map(currency => ({
            ID: currency.Currency_Id,
            CurrencyType: currency.CurrencyShortName
          }));
        
        // Combine the mapped filtered currencies and the new currencies from res
        this.sendCurrencyTypes = [...filteredCurrencies, ...res];

        // Remove duplicates based on ID
        this.sendCurrencyTypes = this.sendCurrencyTypes.reduce((unique, o) => {
          if (!unique.some(obj => obj.ID === o.ID)) {
            unique.push(o);
          }
          return unique;
        }, []);
      
          // this.getReceiveCurrencyType();
        },
        error: () => {
          this.sendCurrencyTypes = [];
        },
        complete: () => { },
      });
  }

  getReceiveCurrencyType() {
    if (this.sendCurrencyTypes?.length) {
      this.receiveCurrencyTypes = this.sendCurrencyTypes;
    }
  }

  allowOneDecimal(event: Event): void {
    const inputElement = event.target as HTMLInputElement;
    const inputValue = inputElement.value;

    // Remove multiple decimals and keep only the first one
    const sanitizedValue = inputValue.replace(/(\.\d*)\./, '$1');

    // Update the input value
    inputElement.value = sanitizedValue;
  }

  get validUser(): boolean {
    const subUserGroupId = getCacheData('SubUserGroup_Id');
    const gUserGroup = getCacheData('G_UserGroup');

    if (subUserGroupId && gUserGroup) {
      const subUserGroupIdNumber = parseInt(subUserGroupId, 10);
      const gUserGroupNumber = parseInt(gUserGroup, 10);

      return subUserGroupIdNumber === 6 && gUserGroupNumber === 1;
    }

    return false;
  }

  get validAuthorizeUser(): boolean {
    const subUserGroupId = getCacheData('SubUserGroup_Id');
    const gUserGroup = getCacheData('G_UserGroup');

    if (subUserGroupId && gUserGroup) {
      const subUserGroupIdNumber = parseInt(subUserGroupId, 10);
      const gUserGroupNumber = parseInt(gUserGroup, 10);

      return subUserGroupIdNumber === 1 && gUserGroupNumber === 1;
    }

    return false;
  }

  update() {
    const deletedCountries = this.getDeletedCountries();
    const updatedCountries = this.getUpdatedAgentWiseCommission();
console.log(deletedCountries)
    this.deleteAgentWiseCommission(deletedCountries);
    // this.updatedAgentWiseCommission(updatedCountries);
  }

  getUpdatedAgentWiseCommission() {
    const updatedCommissions = this.agentWiseCommission
      .filter((con) => con.isChecked)
      .map((con) => ({
        ID: con?.ID,
        StartRange: Number(con?.StartRange),
        EndRange: Number(con?.EndRange),
        BaseToBaseCommissionAmount: Number(con?.BaseToBaseCommissionAmount),
        SendCommissionAmount: Number(con?.PayInCommissionAmount),
        ReceiveCommissionAmount: Number(con?.PayOutCommissionAmount),
        UserID: getCacheData('G_UserID'),
        UpdatedStartRange: Number(con?.StartRange),
        UpdatedEndRange: Number(con?.EndRange),
        UpdatedBaseToBaseCommissionAmount: Number(
          con?.BaseToBaseCommissionAmount
        ),
        UpdatedSendCommissionAmount: Number(con?.PayInCommissionAmount),
        UpdatedReceiveCommissionAmount: Number(con?.PayOutCommissionAmount),
        RecSubAgent: 0,
      }));

    return {
      IsValidUser: this.validUser,
      IsValidAuthorizeUser: this.validAuthorizeUser,
      AgentGridUpdateRequestList: updatedCommissions,
    };
  }

  isValidEndRange(start_range: number, end_range: number): boolean {
    return Number(start_range) < Number(end_range);
  }

  updatedAgentWiseCommission(updatedCountries) {
    if (updatedCountries?.AgentGridUpdateRequestList?.length) {
      this.agentWiseService
        .updateAgentWiseCommissionGrid(updatedCountries)
        .subscribe({
          next: (res: any) => {
            this.searchAgentWiseCommission();
            alert('Agent Wise Commission Update Successfully.');
          },
          error: (err) => {
            // alert(err?.error?.message || 'Something went wrong');
            this.toastrSvc.error(err?.error?.message)
          },
          complete: () => { },
        });
    }
  }

  getDeletedCountries() {
    return this.agentWiseCommission
      .filter((con) => con.isDeleted)
      .map((con) => ({ ID: con?.ID, RecSubAgent: this.selectedSubAgent }));
  }

  deleteAgentWiseCommission(deletedCountries) {
    if (deletedCountries?.length) {
      this.agentWiseService
        .deleteAgentWiseCommission(deletedCountries)
        .subscribe({
          next: (res: any) => {
            this.searchAgentWiseCommission();
            alert('Agent Wise Commission Deleted Successfully.');
          },
          error: (err) => {
            // alert(err?.error?.message || 'Something went wrong');
            this.toastrSvc.error(err?.error?.message)
          },
          complete: () => { },
        });
    }
  }

  formatAgentWiseCommission(array: any = []) {
    for (let index = 0; index < array.length; index++) {
      const element = array[index];
      if (
        element?.BaseToBaseCommissionAmount !== null &&
        element?.BaseToBaseCommissionAmount !== undefined
      ) {
        element.BaseToBaseCommissionAmount = this.formatWithThreeDecimalPlaces(
          element.BaseToBaseCommissionAmount
        );
      }
      if (
        element?.PayInCommissionAmount !== null &&
        element?.PayInCommissionAmount !== undefined
      ) {
        element.PayInCommissionAmount = this.formatWithThreeDecimalPlaces(
          element.PayInCommissionAmount
        );
      }
      if (
        element?.PayOutCommissionAmount !== null &&
        element?.PayOutCommissionAmount !== undefined
      ) {
        element.PayOutCommissionAmount = this.formatWithThreeDecimalPlaces(
          element.PayOutCommissionAmount
        );
      }
      if (
        element?.PayOutFixAmount !== null &&
        element?.PayOutFixAmount !== undefined
      ) {
        element.PayOutFixAmount = this.formatWithThreeDecimalPlaces(
          element.PayOutFixAmount
        );
      }
      if (
        element?.PayOutMaxAmount !== null &&
        element?.PayOutMaxAmount !== undefined
      ) {
        element.PayOutMaxAmount = this.formatWithThreeDecimalPlaces(
          element.PayOutMaxAmount
        );
      }

      if (
        element?.PayOutMinAmount !== null &&
        element?.PayOutMinAmount !== undefined
      ) {
        element.PayOutMinAmount = this.formatWithThreeDecimalPlaces(
          element.PayOutMinAmount
        );
      }
    }
  }

  formatWithThreeDecimalPlaces(value: number | string): string {
    if (value === null || value === undefined) {
      return '';
    }

    const stringValue = value.toString();
    const [integerPart, fractionalPart] = stringValue.split('.');

    if (fractionalPart) {
      // Pad with zeros to ensure 3 decimal places
      return `${integerPart}.${fractionalPart.padEnd(3, '0').slice(0, 3)}`;
    } else {
      // If no decimal places, add 3 zeros
      return `${integerPart}.000`;
    }
  }


  
  onCommissionTypeChange(selectedValue: any) {
    if(selectedValue==2){
     this.showCheckbox = !!selectedValue; // or any other condition
    }else{
     this.additionalCheckboxControlCheck=false
     this.showCheckbox = false; 
     
     this.manageAgentWiseForm.patchValue({
      
       additionalCheckboxControl: false,
 
     });// or any other condition
    }
    
   }
 
   onCheckboxChange(event: any) {
     const isChecked = event.target.checked;
    this.additionalCheckboxControlCheck=isChecked
    
   }

   onSendCurrencyChange(countryId: any) {
    if (countryId != 'None') {
   
      // this.getSendCurrency(CountryID :any,AgentID:any,PayInCurrencyID)
      this.getSendCurrencyType(countryId);
    }
  }
}
