
import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { BeneficiaryComplianceHoldService } from '../services/beneficiary-compliance-hold.service';
import { Router } from '@angular/router'; 
@Component({
  selector: 'app-beneficiary-compliance-hold-view',
  templateUrl: './beneficiary-compliance-hold-view.component.html',
  styleUrls: ['./beneficiary-compliance-hold-view.component.css']
})
export class BeneficiaryComplianceHoldViewComponent {
  beneficiaryData: any;
  beneficiaryNo: any;
  remark: string = '';

  constructor(
    private route: ActivatedRoute,
    private beneficiaryComplianceHoldService: BeneficiaryComplianceHoldService,
    private router: Router
  ) {}
  ngOnInit(): void {
    this.route.params.subscribe((params) => {
      this.beneficiaryNo = params['id'];
      this.complicanceReleasView(this.beneficiaryNo);
    });
  }

  complicanceReleasView(BeneficiaryNo: string) {
    this.beneficiaryComplianceHoldService
      .complicanceReleasView(BeneficiaryNo)
      .subscribe(
        (response: any[]) => {
          if (response.length > 0) {
            this.beneficiaryData = response[0];

            console.log(this.beneficiaryData);
          } else {
            console.error('Empty response or invalid data format');
          }
        },
        (error) => {
          console.error('Error:', error);
        }
      );
  }

  BeneficiaryComplicanceRelease(GUserName: string) {
    this.beneficiaryComplianceHoldService
      .BeneficiaryComplicanceRelease(this.beneficiaryNo, this.remark, GUserName)
      .subscribe(
        (response) => {
          console.log(response);
          this.router.navigate(['/beneficiary-compliance-hold']);
        },
        (error) => {
          console.error('Error:', error);
        }
      );
  }
  BeneficiaryComplicanceReject(GUserName: string) {
    this.beneficiaryComplianceHoldService
      .BeneficiaryComplicanceReject(this.beneficiaryNo, this.remark, GUserName)
      .subscribe(
        (response) => {
          console.log(response);
          this.router.navigate(['/beneficiary-compliance-hold']);
        },
        (error) => {
          console.error('Error:', error);
        }
      );
  }
}
