import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ChannelHoldTransactionService {
  constructor(private http: HttpClient) {}

  getAllRecord(FromDate: any, ToDate: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/channel-hold-transaction/all-record-by-date?FromDate=${FromDate}&ToDate=${ToDate}&TransactionStatus=0&CustomerType=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getRecordByTransactionNo(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/channel-hold-transaction/all-record-by-transaction?TransactionNumber=${TransactionNumber}&TransactionStatus=0&CustomerType=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  approvedTransaction(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/channel-hold-transaction/approved`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  rejectTransaction(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/channel-hold-transaction/reject`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
