import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root'
})
export class AllSendCorridorWiseService {

  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getSendCountryData(Agent_Country_ID: any) {
    return this.http.get(`${this.url}/api/master/reports/all-sent-trxn-for-salesp-report/sendcountry?G_UserID=0&G_Agent_ID=0&Agent_Country_ID=${Agent_Country_ID}`, {
      headers: {
        Authorization: getCacheData('admin_token'),
        Accept: 'application/json',
        username: getCacheData('username'),
      }
    });
  }

  getSendAgentData( CountryID: any) {
    return this.http.get(`${this.url}/api/master/reports/all-sent-trxn-for-salesp-report/send-agent?G_Agent_ID=0&CountryID=${CountryID}`, {
      headers: {
        Authorization: getCacheData('admin_token'),
        Accept: 'application/json',
        username: getCacheData('username'),
      }
    });
  }

  getBranchData(AgentID: any, Agent_Branch_ID: any) {
    return this.http.get(`${this.url}/api/master/reports/all-sent-trxn-for-salesp-report/agent-branch?AgentID=${AgentID}&Agent_Branch_ID=${Agent_Branch_ID}`, {
      headers: {
        Authorization: getCacheData('admin_token'),
        Accept: 'application/json',
        username: getCacheData('username'),
      }
    });
  }



  getReceiveCountryData(UserID: any=0) {
    return this.http.get(`${this.url}/api/master/reports/all-send-receive-txns-report/receive-country?UserID=${UserID}`, {
      headers: {
        Authorization: getCacheData('admin_token'),
        Accept: 'application/json',
        username: getCacheData('username'),
      }
    });
  }

  getReceiveAgentData(ReceiveCountryID: any) {
    return this.http.get(`${this.url}/api/master/reports/all-send-receive-txns-report/receive-agent?ReceiveCountryID=${ReceiveCountryID}`, {
      headers: {
        Authorization: getCacheData('admin_token'),
        Accept: 'application/json',
        username: getCacheData('username'),
      }
    });
  }
  getAllSendReceiveTxnsGridData(payload: any) {
    const headers = this.getHeaders();
    return this.http.post(
      `${this.url}/api/master/reports/all-send-receive-txns-report/grid?txnsReportGridRequest=1`,
      payload,
      { headers }
    );
  }

  private getHeaders(): HttpHeaders {
    return new HttpHeaders({
      Authorization: getCacheData('admin_token'),
      Accept: 'application/json',
      username: getCacheData('username'),
    });
  }
}
