import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root'
})
export class ComplianceReportService {
  url = environment.apiUrl;
  constructor(private http: HttpClient) { }

  getComplianceReportFilteredData() {
    return this.http.get(
      `${environment.apiUrl}/api/complicance/compliance-report/filter`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getAllComplianceReportRecords(filterType: number, fromDate: string, toDate: string) {
    return this.http.get(
      `${environment.apiUrl}/api/complicance/compliance-report/all-record?FilterType=${filterType}&FromDate=${fromDate}&ToDate=${toDate}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

}
