import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class EditTransactionService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getSerchStatusList(payload: any = {}) {
    return this.http.post(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/search/status-list`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  // /api/master/transaction/edit-transaction/payin-country-list
  getTransferTypeList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/transfer-type-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getPayOutCountry() {
    return this.http.get(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/payout-country-list?_MyType=1&_AsPerPermission=true&_CountryID=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getPayinCountryList() {
    return this.http.get(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/payin-country-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getPayinCurrencyList(countryId: any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/payin-currency-list?countryId=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getPayOutCurrencyList(countryId: any) {
    return this.http.get(
      `${environment.apiUrl}/api/mastertransaction/edit-transaction/payout-currency-List?countryId=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentList(countryId) {
    return this.http.get(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/search-mode/agent-list?_TargetCountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentBranch(agentID) {
    return this.http.get(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/agent-branch-list?agentID=${agentID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentUser(AgentID: any, Agent_Branch_ID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/agent-user-list?AgentID=${AgentID}&Agent_Branch_ID=${Agent_Branch_ID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getFillGrid(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/fill-grid`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTransactionDetails(branchId: any = 0, appId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/edit-mode/display-details?BranchID=${branchId}&AppID=${appId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  statusApproved(payload: any) {
    return this.http.patch(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/status-approved`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateTransfer(payload: any) {
    return this.http.patch(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/status-update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
