import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class SendReceiveTransactionListService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}
  getSendReceiveTransactionReport() {
    return this.http.get(
      `${this.url}/api/master/reports/agent-report/send-receive-trxn/select-report`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getCountryList() {
    return this.http.get(
      `${this.url}/api/master/reports/agent-report/send-receive-trxn/country?CountryType=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getAgentsByCountry(countryId: any) {
    return this.http.get(
      `${this.url}/api/master/reports/agent-report/send-receive-trxn/agents?countryId=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
