import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class SentTransactionSummaryService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getCountryList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-status/country-list?UserId=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveCountryList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/receive-transaction-status/country-list?UserId=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentList(countryId: any = 1) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-sent-summary/agent?CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAllRecord(
    fromDate: any,
    toDate: any,
    modeType: any = -1,
    sendCountryId: any = 0,
    agentId: any = -1,
    receiveCountryId: any = 0
  ) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-sent-summary/all-record?FromDate=${fromDate}&ToDate=${toDate}&ModeType=${modeType}&SendCountryID=${sendCountryId}&AgentID=${agentId}&ReceiveCountryID=${receiveCountryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
