import { Component } from '@angular/core';
import { UploadTransactionsFileService } from '../upload-transactions-file.service';

@Component({
  selector: 'app-upload-transaction',
  templateUrl: './upload-transaction.component.html',
  styleUrls: ['./upload-transaction.component.css'],
})
export class UploadTransactionComponent {
  constructor(
    private uploadTransactionFileSvc: UploadTransactionsFileService
  ) {}

  selectedCountry: any = '0';
  selectedBank: any = '0';
  selectedFile: any = '';
  isLoading: boolean = false;

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }

  onFileSelected(event: any) {
    const file: File = event.target.files[0];
    if (file) {
      if (file.type === 'text/plain') {
        // File is a text file, you can process it further
        this.selectedFile = file;
      } else {
        // File is not a text file, show an error message or handle it accordingly
        event.target.value = null;
        alert('Please select a text file.');
      }
    }
  }

  uploadTransaction() {
    if (!this.selectedFile) {
      alert('Please select a Text file.');
      return;
    }
    this.isLoading = true;
    const formData = new FormData();
    formData.append('file', this.selectedFile);

    this.uploadTransactionFileSvc.uploadTransaction(formData).subscribe({
      next: (res: any) => {
        alert(res);
      },
      complete: () => {
        this.isLoading = false;
      },
    });
  }
}
