import { Component } from '@angular/core';
import { VatService } from '../services/vat.service';

@Component({
  selector: 'app-vat',
  templateUrl: './vat.component.html',
  styleUrls: ['./vat.component.css'],
})
export class VatComponent {
  vatAccountNumber: any = '';
  vatPercentage: any = '';

  constructor(private vatService: VatService) {}

  ngOnInit(): void {
    this.getVatInformationList();
  }

  getVatInformationList() {
    this.vatService.getVatInformationList().subscribe({
      next: (res: any) => {
        this.vatAccountNumber = res?.[0]?.AccountNumber;
        this.vatPercentage = res?.[0]?.VATPercent;
      },
      error: (err) => {
        this.vatAccountNumber = '';
        this.vatPercentage = '';
      },
      complete: () => {},
    });
  }

  updateVatInformation() {
    if (!this.vatAccountNumber) {
      alert('Please Fill Vat Account Number.');
      return;
    }

    if (!this.vatPercentage) {
      alert('Please Fill Vat Percentage.');
      return;
    }

    this.vatService
      .updateVatInformation(1, this.vatAccountNumber, this.vatPercentage)
      .subscribe({
        next: (res: any) => {
          this.getVatInformationList();
          alert('Record updated successfully.');
        },
        error: (err) => {
          alert(err?.error?.message || 'Something went wrong');
        },
        complete: () => {},
      });
  }

  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
